//#import <objectbase.h>
//#import <activity.h>
//#import <collections.h>
//#import <simtools.h>

#import <simtoolsgui.h>
#import <analysis.h>
#import <simtoolsgui/GUISwarm.h>
#import "BankModelSwarm.h"

@interface BankObserverSwarm : GUISwarm {
  int displayFrequency;
  int interactiveGraph;
  id displayActions;	
  id displaySchedule;

  BankModelSwarm * bankModelSwarm;

  id <Canvas> graphCanvas ;

  id <Graph> investorGraph;			  
  id <GraphElement> investorData;			  
  id <ActiveGraph> investorGrapher;

  id <Entropy> investorEntropy;   		  
  id <GraphElement> borrowerData;	
  id <ActiveGraph> borrowerGrapher;
  id <Entropy> borrowerEntropy;   		  
 	  
  id activeBanks ;
  
  /*
  XColormap * colormap;				  // allocate colours
  ZoomRaster * worldRaster;			  // 2d display widget


  Value2dDisplay * heatDisplay;			  // display the heat
  Object2dDisplay * bankDisplay;		  // display the banks
  */
}

+createBegin: (id) aZone;
-createEnd;
-buildObjects;
-buildActions;
-activateIn: (id) swarmContext;

-redistribute ;

- _investorGraphDeath_ : caller;

@end
