 
#import <graph.h>

@interface FEntity: DiGraphNode {
  int prevROI ;
  int prevCapital ;
  double capital ;
  int investCount ;
  int loanCount ;
  int ciclo ; // ***
  double IOPG ; // ***
  int IOPbool ;
  double Esperienza ; // ***
  double Income; // ***
  double averageIncome;
  double TranCost; // ***
  double TranCostBas; // ***
  int totalAgentNum ;
  id investLink ;
  id borrowLink ;
  id model ;
}

- setCanvas : aCanvas;
-(int) getPrevROI ;
-(int) getPrevCapital ;
-setEntityName: (char *) the_name ;
-setIncome: (double) aVal andAv: (double) avInc; // ***
-setTranCostBas: (double) aVal ; // ***
-setModel: aModelSwarm ;
-setTotalAgentNum: (int) total ;
-(int)investingIn: anFEntity ;
-(int)borrowingFrom: anFEntity ;

-makeInvestLinkTo: aFEntity ;
-makeBorrowLinkTo: aFEntity ;
-transferInvestLinkTo: aFEntity ;
-transferBorrowLinkTo: aFEntity ;

-attrIncome ; // ***
-attrTranCostBas; // ***
-encounter ;
-invest ;
-generateIOP ;
-lend ;
-(double) generateROI: (double) investment ;

-(int) incident ;
-(int) countInvestors ;
-(int) countBorrowers ; // Note: we are only concerned with the links
                        // (whether or not the node actually borrowed 
                        // on a given turn)...

-(double) getInvestorLinkProbability ;
-(double) getBorrowLinkProbability ;

@end



